﻿using System;
using System.Xml;
using System.Xml.Serialization;
using System.IO;
using System.Reflection;

namespace LogicData
{
    /// <summary>
    /// 채팅 관련 데이터
    /// </summary>
    public enum ChatType
    {
        NormalChat = 0,
        SystemChat
    }

    public class ChatData
    {
        public string   ChatMsg { get; set; }
        public string   NickName { get; set; }
        public ChatType Type { get; set; }
    }

    public class ChatDataManager
    {
        public ChatData chatData = new ChatData();

        public ChatDataManager(string chatMsg, string nickName, ChatType chatType)
        {
            chatData.ChatMsg = chatMsg;
            chatData.NickName = nickName;
            chatData.Type = chatType;
        }
        public ChatDataManager(string xml)
        {
            GetData(xml);
        }

        public string GetXML()
        {
            try
            {
                StringWriter sw = new StringWriter();
                XmlSerializer xm = new XmlSerializer(typeof(ChatData));
                xm.Serialize(sw, chatData);
                return sw.ToString();
            }
            catch (Exception e)
            {
                return "";
            }
        }
        public ChatData GetData(string xml)
        {
            try
            {
                StringReader sr = new StringReader(xml);
                XmlSerializer xs = new XmlSerializer(typeof(ChatData));
                chatData = (ChatData)xs.Deserialize(sr);
                return chatData;
            }
            catch (Exception e)
            {
                return chatData;
            }
        }
    }
}
