﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Text;
using System.Net;
using System.Threading;
using System.Net.Sockets;
using System.Reflection;
using System.Xml;
using System.Xml.Serialization;
using System.IO;

namespace GameLogic
{
    class LogicUtil
    {
        public  void LogError(Exception exp, string from)
        {
            string appFullPath = Assembly.GetCallingAssembly().Location;
            string logPath = appFullPath.Substring(0, appFullPath.LastIndexOf("\\")) + ".log";
            StreamWriter writer = new StreamWriter(logPath, true);
            try
            {
                writer.WriteLine(logPath,
                    String.Format("Error in " + from + ": {0} \r\n StackTrace: {1}", exp.Message, exp.StackTrace));
            }
            catch { }
            finally
            {
                writer.Close();
            }
        }
        public Client FindClient(string IPFrom)
        {
            return LogicManager.Instance.ClientList[IPFrom];
        }

        public int[] NumberRandom0to9(int count)
        {
            int[] array = new int[count];
            Random r = new Random();

            for (int i = 0; i < count; i++)
            {
                array[i] = r.Next(9);
                for (int k = 0; k < i; k++)
                    if (array[k] == array[i])
                    {
                        i--;
                        break;
                    }
            }
            return array;
        }

        /// <summary>
        /// 랜덤으로 숫자+문자로 문자를 발생시킨다. 2번쨰 인자로 랜덤을 위해서 더해줄 숫자를 아무 숫자나 넣어준다.
        /// </summary>
        /// <param name="TotLen"></param>
        /// <param name="randomAddCount"></param>
        /// <returns></returns>
        public string GetRandomPassword(int TotLen, int randomAddCount)
        {
            string pword = "abcdefghijklmnopqrxtuvwxyz0123456789";
            string npwd = null;
            int nCnt = 0;

            Random rnd = new Random(DateTime.Now.Millisecond + randomAddCount);
            int iRet = 0;
            for(int i=0;i<TotLen;i++)
            {
                iRet = rnd.Next(0, pword.Length - 1);
                npwd = npwd + pword[iRet].ToString();
            }
            ASCIIEncoding ascii = new ASCIIEncoding();
            Byte[] byte_npwd = ascii.GetBytes(npwd);
            int cCnt = 0;
            foreach(Byte b in byte_npwd)
            {
                if( 48 >= Convert.ToInt32(b) || 57 <= Convert.ToInt32(b))
                    nCnt++;
                else
                    cCnt++;
            }
            if(nCnt == 0)
            {
                iRet = rnd.Next(26, pword.Length);
                npwd = npwd.Substring(1, 14) + pword[iRet].ToString();
            }
            if(cCnt == 0)
            {
                iRet = rnd.Next(0, 25);
                npwd = npwd.Substring(1, 14) + pword[iRet].ToString();
            }
            return npwd;
        }
    }
}