﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Threading;

using GameLogic;

namespace Network
{
    delegate void dStringMsg(string msgFrom);
    delegate void dString(String d);
    delegate void dStringIP(String d, string IPFrom);
    delegate void dStringSelect(String d, Client c);

    interface INetwork
    {
        void Start();
        void Stop();
        void SendToAll(String d);
        void SendToAll(String d, Client except);
        void SendToOne(String d, Client c);
    }

    public class TCPTransfer
    {
        private Socket s;
        private NetworkStream sendStm, recvStm;
        private StreamWriter writer;
        private StreamReader reader;
        public void HookSocket(Socket s)
        {
            this.s = s;
            sendStm = new NetworkStream(s);
            recvStm = new NetworkStream(s);

            writer = new StreamWriter(sendStm);
            reader = new StreamReader(recvStm);
        }

        public Socket MySocket
        { get { return s; } }

        public virtual void Send(String d)
        {
            try
            {
                writer.WriteLine(d);
                writer.Flush();
            }
            catch
            {
                return;
            }
        }

        public virtual String Receive()
        {
            string d = null;
            try
            {
                char[] chars = new char[1024];
                int i = 0;
                i = reader.Read(chars, 0, 1024);

                d = new String(chars, 0, i);
                //Console.WriteLine(d);
            }
            catch (Exception e)
            {
                return e.Message + "\r\n전송문제로 데이터를 수신받지 못했습니다";
            }

            return d;
        }
    }

    class MessageQueue
    {
        private Queue<String> que;

        public MessageQueue()
        { que = new Queue<String>(); }

        public void Enqueue(String item)
        { lock (que) que.Enqueue(item); }

        public String Dequeue()
        { lock (que)	return que.Count != 0 ? que.Dequeue() : null; }

        public void Clear()
        { lock (que) que.Clear(); }
    }
}